git-am.shon commit Update draft release notes to 1.7.7 (826603d)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [(<mbox>|<Maildir>)...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14q,quiet         be quiet
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flag to git-mailinfo
  18keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  19no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  20c,scissors      strip everything before a scissors line
  21whitespace=     pass it through git-apply
  22ignore-space-change pass it through git-apply
  23ignore-whitespace pass it through git-apply
  24directory=      pass it through git-apply
  25exclude=        pass it through git-apply
  26C=              pass it through git-apply
  27p=              pass it through git-apply
  28patch-format=   format the patch(es) are in
  29reject          pass it through git-apply
  30resolvemsg=     override error message when patch failure occurs
  31continue        continue applying patches after resolving a conflict
  32r,resolved      synonyms for --continue
  33skip            skip the current patch
  34abort           restore the original branch and abort the patching operation.
  35committer-date-is-author-date    lie about committer date
  36ignore-date     use current timestamp for author date
  37rerere-autoupdate update the index with reused conflict resolution if possible
  38rebasing*       (internal use for git-rebase)"
  39
  40. git-sh-setup
  41. git-sh-i18n
  42prefix=$(git rev-parse --show-prefix)
  43set_reflog_action am
  44require_work_tree
  45cd_to_toplevel
  46
  47git var GIT_COMMITTER_IDENT >/dev/null ||
  48        die "$(gettext "You need to set your committer info first")"
  49
  50if git rev-parse --verify -q HEAD >/dev/null
  51then
  52        HAS_HEAD=yes
  53else
  54        HAS_HEAD=
  55fi
  56
  57cmdline="git am"
  58if test '' != "$interactive"
  59then
  60        cmdline="$cmdline -i"
  61fi
  62if test '' != "$threeway"
  63then
  64        cmdline="$cmdline -3"
  65fi
  66
  67sq () {
  68        git rev-parse --sq-quote "$@"
  69}
  70
  71stop_here () {
  72    echo "$1" >"$dotest/next"
  73    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  74    exit 1
  75}
  76
  77safe_to_abort () {
  78        if test -f "$dotest/dirtyindex"
  79        then
  80                return 1
  81        fi
  82
  83        if ! test -s "$dotest/abort-safety"
  84        then
  85                return 0
  86        fi
  87
  88        abort_safety=$(cat "$dotest/abort-safety")
  89        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  90        then
  91                return 0
  92        fi
  93                gettextln "You seem to have moved HEAD since the last 'am' failure.
  94Not rewinding to ORIG_HEAD" >&2
  95        return 1
  96}
  97
  98stop_here_user_resolve () {
  99    if [ -n "$resolvemsg" ]; then
 100            printf '%s\n' "$resolvemsg"
 101            stop_here $1
 102    fi
 103    eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
 104If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 105To restore the original branch and stop patching run \"\$cmdline --abort\"."
 106
 107    stop_here $1
 108}
 109
 110go_next () {
 111        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 112                "$dotest/patch" "$dotest/info"
 113        echo "$next" >"$dotest/next"
 114        this=$next
 115}
 116
 117cannot_fallback () {
 118        echo "$1"
 119        gettextln "Cannot fall back to three-way merge."
 120        exit 1
 121}
 122
 123fall_back_3way () {
 124    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
 125
 126    rm -fr "$dotest"/patch-merge-*
 127    mkdir "$dotest/patch-merge-tmp-dir"
 128
 129    # First see if the patch records the index info that we can use.
 130    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
 131        "$dotest/patch" &&
 132    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 133    git write-tree >"$dotest/patch-merge-base+" ||
 134    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 135
 136    say Using index info to reconstruct a base tree...
 137    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 138        git apply --cached <"$dotest/patch"
 139    then
 140        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 141        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 142    else
 143        cannot_fallback "$(gettext "Did you hand edit your patch?
 144It does not apply to blobs recorded in its index.")"
 145    fi
 146
 147    test -f "$dotest/patch-merge-index" &&
 148    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 149    orig_tree=$(cat "$dotest/patch-merge-base") &&
 150    rm -fr "$dotest"/patch-merge-* || exit 1
 151
 152    say "$(gettext "Falling back to patching base and 3-way merge...")"
 153
 154    # This is not so wrong.  Depending on which base we picked,
 155    # orig_tree may be wildly different from ours, but his_tree
 156    # has the same set of wildly different changes in parts the
 157    # patch did not touch, so recursive ends up canceling them,
 158    # saying that we reverted all those changes.
 159
 160    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 161    export GITHEAD_$his_tree
 162    if test -n "$GIT_QUIET"
 163    then
 164            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 165    fi
 166    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 167            git rerere $allow_rerere_autoupdate
 168            echo Failed to merge in the changes.
 169            exit 1
 170    }
 171    unset GITHEAD_$his_tree
 172}
 173
 174clean_abort () {
 175        test $# = 0 || echo >&2 "$@"
 176        rm -fr "$dotest"
 177        exit 1
 178}
 179
 180patch_format=
 181
 182check_patch_format () {
 183        # early return if patch_format was set from the command line
 184        if test -n "$patch_format"
 185        then
 186                return 0
 187        fi
 188
 189        # we default to mbox format if input is from stdin and for
 190        # directories
 191        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 192        then
 193                patch_format=mbox
 194                return 0
 195        fi
 196
 197        # otherwise, check the first few non-blank lines of the first
 198        # patch to try to detect its format
 199        {
 200                # Start from first line containing non-whitespace
 201                l1=
 202                while test -z "$l1"
 203                do
 204                        read l1
 205                done
 206                read l2
 207                read l3
 208                case "$l1" in
 209                "From "* | "From: "*)
 210                        patch_format=mbox
 211                        ;;
 212                '# This series applies on GIT commit'*)
 213                        patch_format=stgit-series
 214                        ;;
 215                "# HG changeset patch")
 216                        patch_format=hg
 217                        ;;
 218                *)
 219                        # if the second line is empty and the third is
 220                        # a From, Author or Date entry, this is very
 221                        # likely an StGIT patch
 222                        case "$l2,$l3" in
 223                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 224                                patch_format=stgit
 225                                ;;
 226                        *)
 227                                ;;
 228                        esac
 229                        ;;
 230                esac
 231                if test -z "$patch_format" &&
 232                        test -n "$l1" &&
 233                        test -n "$l2" &&
 234                        test -n "$l3"
 235                then
 236                        # This begins with three non-empty lines.  Is this a
 237                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 238                        # discarding the indented remainder of folded lines,
 239                        # and see if it looks like that they all begin with the
 240                        # header field names...
 241                        tr -d '\015' <"$1" |
 242                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 243                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 244                        patch_format=mbox
 245                fi
 246        } < "$1" || clean_abort
 247}
 248
 249split_patches () {
 250        case "$patch_format" in
 251        mbox)
 252                if test -n "$rebasing" || test t = "$keepcr"
 253                then
 254                    keep_cr=--keep-cr
 255                else
 256                    keep_cr=
 257                fi
 258                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 259                clean_abort
 260                ;;
 261        stgit-series)
 262                if test $# -ne 1
 263                then
 264                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 265                fi
 266                series_dir=`dirname "$1"`
 267                series_file="$1"
 268                shift
 269                {
 270                        set x
 271                        while read filename
 272                        do
 273                                set "$@" "$series_dir/$filename"
 274                        done
 275                        # remove the safety x
 276                        shift
 277                        # remove the arg coming from the first-line comment
 278                        shift
 279                } < "$series_file" || clean_abort
 280                # set the patch format appropriately
 281                patch_format=stgit
 282                # now handle the actual StGIT patches
 283                split_patches "$@"
 284                ;;
 285        stgit)
 286                this=0
 287                for stgit in "$@"
 288                do
 289                        this=`expr "$this" + 1`
 290                        msgnum=`printf "%0${prec}d" $this`
 291                        # Perl version of StGIT parse_patch. The first nonemptyline
 292                        # not starting with Author, From or Date is the
 293                        # subject, and the body starts with the next nonempty
 294                        # line not starting with Author, From or Date
 295                        perl -ne 'BEGIN { $subject = 0 }
 296                                if ($subject > 1) { print ; }
 297                                elsif (/^\s+$/) { next ; }
 298                                elsif (/^Author:/) { print s/Author/From/ ; }
 299                                elsif (/^(From|Date)/) { print ; }
 300                                elsif ($subject) {
 301                                        $subject = 2 ;
 302                                        print "\n" ;
 303                                        print ;
 304                                } else {
 305                                        print "Subject: ", $_ ;
 306                                        $subject = 1;
 307                                }
 308                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 309                done
 310                echo "$this" > "$dotest/last"
 311                this=
 312                msgnum=
 313                ;;
 314        *)
 315                if test -n "$parse_patch" ; then
 316                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 317                else
 318                        clean_abort "$(gettext "Patch format detection failed.")"
 319                fi
 320                ;;
 321        esac
 322}
 323
 324prec=4
 325dotest="$GIT_DIR/rebase-apply"
 326sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 327resolvemsg= resume= scissors= no_inbody_headers=
 328git_apply_opt=
 329committer_date_is_author_date=
 330ignore_date=
 331allow_rerere_autoupdate=
 332
 333if test "$(git config --bool --get am.keepcr)" = true
 334then
 335    keepcr=t
 336fi
 337
 338while test $# != 0
 339do
 340        case "$1" in
 341        -i|--interactive)
 342                interactive=t ;;
 343        -b|--binary)
 344                : ;;
 345        -3|--3way)
 346                threeway=t ;;
 347        -s|--signoff)
 348                sign=t ;;
 349        -u|--utf8)
 350                utf8=t ;; # this is now default
 351        --no-utf8)
 352                utf8= ;;
 353        -k|--keep)
 354                keep=t ;;
 355        -c|--scissors)
 356                scissors=t ;;
 357        --no-scissors)
 358                scissors=f ;;
 359        -r|--resolved|--continue)
 360                resolved=t ;;
 361        --skip)
 362                skip=t ;;
 363        --abort)
 364                abort=t ;;
 365        --rebasing)
 366                rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
 367        -d|--dotest)
 368                die "$(gettext "-d option is no longer supported.  Do not use.")"
 369                ;;
 370        --resolvemsg)
 371                shift; resolvemsg=$1 ;;
 372        --whitespace|--directory|--exclude)
 373                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 374        -C|-p)
 375                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 376        --patch-format)
 377                shift ; patch_format="$1" ;;
 378        --reject|--ignore-whitespace|--ignore-space-change)
 379                git_apply_opt="$git_apply_opt $1" ;;
 380        --committer-date-is-author-date)
 381                committer_date_is_author_date=t ;;
 382        --ignore-date)
 383                ignore_date=t ;;
 384        --rerere-autoupdate|--no-rerere-autoupdate)
 385                allow_rerere_autoupdate="$1" ;;
 386        -q|--quiet)
 387                GIT_QUIET=t ;;
 388        --keep-cr)
 389                keepcr=t ;;
 390        --no-keep-cr)
 391                keepcr=f ;;
 392        --)
 393                shift; break ;;
 394        *)
 395                usage ;;
 396        esac
 397        shift
 398done
 399
 400# If the dotest directory exists, but we have finished applying all the
 401# patches in them, clear it out.
 402if test -d "$dotest" &&
 403   last=$(cat "$dotest/last") &&
 404   next=$(cat "$dotest/next") &&
 405   test $# != 0 &&
 406   test "$next" -gt "$last"
 407then
 408   rm -fr "$dotest"
 409fi
 410
 411if test -d "$dotest"
 412then
 413        case "$#,$skip$resolved$abort" in
 414        0,*t*)
 415                # Explicit resume command and we do not have file, so
 416                # we are happy.
 417                : ;;
 418        0,)
 419                # No file input but without resume parameters; catch
 420                # user error to feed us a patch from standard input
 421                # when there is already $dotest.  This is somewhat
 422                # unreliable -- stdin could be /dev/null for example
 423                # and the caller did not intend to feed us a patch but
 424                # wanted to continue unattended.
 425                test -t 0
 426                ;;
 427        *)
 428                false
 429                ;;
 430        esac ||
 431        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 432        resume=yes
 433
 434        case "$skip,$abort" in
 435        t,t)
 436                die "$(gettext "Please make up your mind. --skip or --abort?")"
 437                ;;
 438        t,)
 439                git rerere clear
 440                git read-tree --reset -u HEAD HEAD
 441                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 442                git reset HEAD
 443                git update-ref ORIG_HEAD $orig_head
 444                ;;
 445        ,t)
 446                if test -f "$dotest/rebasing"
 447                then
 448                        exec git rebase --abort
 449                fi
 450                git rerere clear
 451                if safe_to_abort
 452                then
 453                        git read-tree --reset -u HEAD ORIG_HEAD
 454                        git reset ORIG_HEAD
 455                fi
 456                rm -fr "$dotest"
 457                exit ;;
 458        esac
 459        rm -f "$dotest/dirtyindex"
 460else
 461        # Make sure we are not given --skip, --resolved, nor --abort
 462        test "$skip$resolved$abort" = "" ||
 463                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 464
 465        # Start afresh.
 466        mkdir -p "$dotest" || exit
 467
 468        if test -n "$prefix" && test $# != 0
 469        then
 470                first=t
 471                for arg
 472                do
 473                        test -n "$first" && {
 474                                set x
 475                                first=
 476                        }
 477                        if is_absolute_path "$arg"
 478                        then
 479                                set "$@" "$arg"
 480                        else
 481                                set "$@" "$prefix$arg"
 482                        fi
 483                done
 484                shift
 485        fi
 486
 487        check_patch_format "$@"
 488
 489        split_patches "$@"
 490
 491        # -i can and must be given when resuming; everything
 492        # else is kept
 493        echo " $git_apply_opt" >"$dotest/apply-opt"
 494        echo "$threeway" >"$dotest/threeway"
 495        echo "$sign" >"$dotest/sign"
 496        echo "$utf8" >"$dotest/utf8"
 497        echo "$keep" >"$dotest/keep"
 498        echo "$keepcr" >"$dotest/keepcr"
 499        echo "$scissors" >"$dotest/scissors"
 500        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 501        echo "$GIT_QUIET" >"$dotest/quiet"
 502        echo 1 >"$dotest/next"
 503        if test -n "$rebasing"
 504        then
 505                : >"$dotest/rebasing"
 506        else
 507                : >"$dotest/applying"
 508                if test -n "$HAS_HEAD"
 509                then
 510                        git update-ref ORIG_HEAD HEAD
 511                else
 512                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 513                fi
 514        fi
 515fi
 516
 517git update-index -q --refresh
 518
 519case "$resolved" in
 520'')
 521        case "$HAS_HEAD" in
 522        '')
 523                files=$(git ls-files) ;;
 524        ?*)
 525                files=$(git diff-index --cached --name-only HEAD --) ;;
 526        esac || exit
 527        if test "$files"
 528        then
 529                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 530                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 531        fi
 532esac
 533
 534if test "$(cat "$dotest/utf8")" = t
 535then
 536        utf8=-u
 537else
 538        utf8=-n
 539fi
 540if test "$(cat "$dotest/keep")" = t
 541then
 542        keep=-k
 543fi
 544case "$(cat "$dotest/keepcr")" in
 545t)
 546        keepcr=--keep-cr ;;
 547f)
 548        keepcr=--no-keep-cr ;;
 549esac
 550case "$(cat "$dotest/scissors")" in
 551t)
 552        scissors=--scissors ;;
 553f)
 554        scissors=--no-scissors ;;
 555esac
 556if test "$(cat "$dotest/no_inbody_headers")" = t
 557then
 558        no_inbody_headers=--no-inbody-headers
 559else
 560        no_inbody_headers=
 561fi
 562if test "$(cat "$dotest/quiet")" = t
 563then
 564        GIT_QUIET=t
 565fi
 566if test "$(cat "$dotest/threeway")" = t
 567then
 568        threeway=t
 569fi
 570git_apply_opt=$(cat "$dotest/apply-opt")
 571if test "$(cat "$dotest/sign")" = t
 572then
 573        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 574                        s/>.*/>/
 575                        s/^/Signed-off-by: /'
 576                `
 577else
 578        SIGNOFF=
 579fi
 580
 581last=`cat "$dotest/last"`
 582this=`cat "$dotest/next"`
 583if test "$skip" = t
 584then
 585        this=`expr "$this" + 1`
 586        resume=
 587fi
 588
 589while test "$this" -le "$last"
 590do
 591        msgnum=`printf "%0${prec}d" $this`
 592        next=`expr "$this" + 1`
 593        test -f "$dotest/$msgnum" || {
 594                resume=
 595                go_next
 596                continue
 597        }
 598
 599        # If we are not resuming, parse and extract the patch information
 600        # into separate files:
 601        #  - info records the authorship and title
 602        #  - msg is the rest of commit log message
 603        #  - patch is the patch body.
 604        #
 605        # When we are resuming, these files are either already prepared
 606        # by the user, or the user can tell us to do so by --resolved flag.
 607        case "$resume" in
 608        '')
 609                git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 610                        <"$dotest/$msgnum" >"$dotest/info" ||
 611                        stop_here $this
 612
 613                # skip pine's internal folder data
 614                sane_grep '^Author: Mail System Internal Data$' \
 615                        <"$dotest"/info >/dev/null &&
 616                        go_next && continue
 617
 618                test -s "$dotest/patch" || {
 619                        eval_gettextln "Patch is empty.  Was it split wrong?
 620If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 621To restore the original branch and stop patching run \"\$cmdline --abort\"."
 622                        stop_here $this
 623                }
 624                rm -f "$dotest/original-commit" "$dotest/author-script"
 625                if test -f "$dotest/rebasing" &&
 626                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 627                                -e q "$dotest/$msgnum") &&
 628                        test "$(git cat-file -t "$commit")" = commit
 629                then
 630                        git cat-file commit "$commit" |
 631                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 632                        echo "$commit" > "$dotest/original-commit"
 633                        get_author_ident_from_commit "$commit" > "$dotest/author-script"
 634                else
 635                        {
 636                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 637                                echo
 638                                cat "$dotest/msg"
 639                        } |
 640                        git stripspace > "$dotest/msg-clean"
 641                fi
 642                ;;
 643        esac
 644
 645        if test -f "$dotest/author-script"
 646        then
 647                eval $(cat "$dotest/author-script")
 648        else
 649                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 650                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 651                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 652        fi
 653
 654        if test -z "$GIT_AUTHOR_EMAIL"
 655        then
 656                gettextln "Patch does not have a valid e-mail address."
 657                stop_here $this
 658        fi
 659
 660        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 661
 662        case "$resume" in
 663        '')
 664            if test '' != "$SIGNOFF"
 665            then
 666                LAST_SIGNED_OFF_BY=`
 667                    sed -ne '/^Signed-off-by: /p' \
 668                    "$dotest/msg-clean" |
 669                    sed -ne '$p'
 670                `
 671                ADD_SIGNOFF=`
 672                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 673                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 674                    echo "$SIGNOFF"
 675                }`
 676            else
 677                ADD_SIGNOFF=
 678            fi
 679            {
 680                if test -s "$dotest/msg-clean"
 681                then
 682                        cat "$dotest/msg-clean"
 683                fi
 684                if test '' != "$ADD_SIGNOFF"
 685                then
 686                        echo "$ADD_SIGNOFF"
 687                fi
 688            } >"$dotest/final-commit"
 689            ;;
 690        *)
 691                case "$resolved$interactive" in
 692                tt)
 693                        # This is used only for interactive view option.
 694                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 695                        ;;
 696                esac
 697        esac
 698
 699        resume=
 700        if test "$interactive" = t
 701        then
 702            test -t 0 ||
 703            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 704            action=again
 705            while test "$action" = again
 706            do
 707                gettextln "Commit Body is:"
 708                echo "--------------------------"
 709                cat "$dotest/final-commit"
 710                echo "--------------------------"
 711                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 712                # in your translation. The program will only accept English
 713                # input at this point.
 714                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 715                read reply
 716                case "$reply" in
 717                [yY]*) action=yes ;;
 718                [aA]*) action=yes interactive= ;;
 719                [nN]*) action=skip ;;
 720                [eE]*) git_editor "$dotest/final-commit"
 721                       action=again ;;
 722                [vV]*) action=again
 723                       git_pager "$dotest/patch" ;;
 724                *)     action=again ;;
 725                esac
 726            done
 727        else
 728            action=yes
 729        fi
 730
 731        if test -f "$dotest/final-commit"
 732        then
 733                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 734        else
 735                FIRSTLINE=""
 736        fi
 737
 738        if test $action = skip
 739        then
 740                go_next
 741                continue
 742        fi
 743
 744        if test -x "$GIT_DIR"/hooks/applypatch-msg
 745        then
 746                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 747                stop_here $this
 748        fi
 749
 750        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 751
 752        case "$resolved" in
 753        '')
 754                # When we are allowed to fall back to 3-way later, don't give
 755                # false errors during the initial attempt.
 756                squelch=
 757                if test "$threeway" = t
 758                then
 759                        squelch='>/dev/null 2>&1 '
 760                fi
 761                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 762                apply_status=$?
 763                ;;
 764        t)
 765                # Resolved means the user did all the hard work, and
 766                # we do not have to do any patch application.  Just
 767                # trust what the user has in the index file and the
 768                # working tree.
 769                resolved=
 770                git diff-index --quiet --cached HEAD -- && {
 771                        gettextln "No changes - did you forget to use 'git add'?
 772If there is nothing left to stage, chances are that something else
 773already introduced the same changes; you might want to skip this patch."
 774                        stop_here_user_resolve $this
 775                }
 776                unmerged=$(git ls-files -u)
 777                if test -n "$unmerged"
 778                then
 779                        gettextln "You still have unmerged paths in your index
 780did you forget to use 'git add'?"
 781                        stop_here_user_resolve $this
 782                fi
 783                apply_status=0
 784                git rerere
 785                ;;
 786        esac
 787
 788        if test $apply_status != 0 && test "$threeway" = t
 789        then
 790                if (fall_back_3way)
 791                then
 792                    # Applying the patch to an earlier tree and merging the
 793                    # result may have produced the same tree as ours.
 794                    git diff-index --quiet --cached HEAD -- && {
 795                        say "$(gettext "No changes -- Patch already applied.")"
 796                        go_next
 797                        continue
 798                    }
 799                    # clear apply_status -- we have successfully merged.
 800                    apply_status=0
 801                fi
 802        fi
 803        if test $apply_status != 0
 804        then
 805                eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
 806                stop_here_user_resolve $this
 807        fi
 808
 809        if test -x "$GIT_DIR"/hooks/pre-applypatch
 810        then
 811                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 812        fi
 813
 814        tree=$(git write-tree) &&
 815        commit=$(
 816                if test -n "$ignore_date"
 817                then
 818                        GIT_AUTHOR_DATE=
 819                fi
 820                parent=$(git rev-parse --verify -q HEAD) ||
 821                say >&2 "$(gettext "applying to an empty history")"
 822
 823                if test -n "$committer_date_is_author_date"
 824                then
 825                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 826                        export GIT_COMMITTER_DATE
 827                fi &&
 828                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 829        ) &&
 830        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 831        stop_here $this
 832
 833        if test -f "$dotest/original-commit"; then
 834                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 835        fi
 836
 837        if test -x "$GIT_DIR"/hooks/post-applypatch
 838        then
 839                "$GIT_DIR"/hooks/post-applypatch
 840        fi
 841
 842        go_next
 843done
 844
 845if test -s "$dotest"/rewritten; then
 846    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 847    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 848        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 849    fi
 850fi
 851
 852rm -fr "$dotest"
 853git gc --auto